# template for PSet #4, Task #3
import PS4_tests
import numpy

############THE ANSWERS!
def correct_errors(codeword,nrows,ncols): 
    # the raw data bits
    data = codeword[0:nrows*ncols]
 
    # do row & column parity checks, correct indicated error

    # find rows with parity errors, remember last one
    rerr = None
    rcount = 0
    pindex = nrows*ncols  # index of row parity bits
    for row in xrange(nrows):
        if sum(codeword[row*ncols:(row+1)*ncols]) % 2 != codeword[pindex+row]:
            rerr = row
            rcount += 1

    # find columns with parity errors, remember last one
    cerr = None
    ccount = 0
    pindex += nrows  # index of col parity bits
    for col in xrange(ncols):
        # data bits from col
        if sum(codeword[col:nrows*ncols:ncols]) % 2 != codeword[pindex+col]:
            cerr = col
            ccount += 1

    # look for correctable error
    if rcount == 1 and ccount == 1:
        # flip offending data bit
        data[rerr*ncols + cerr] ^= 1

    # return the posibly corrected data
    return data

if __name__ == '__main__':
    PS4_tests.test_correct_errors(correct_errors)
